#pragma option -3 -r -Z -O2 -a
#include <stdio.h>
#include <math.h>

#define PREC	0.0001

double len;
int n;
struct xy {
	double x, y;
} a[100], cont;

double dist(struct xy *p, struct xy *q)
{
	return((p->x - q->x) * (p->x - q->x) + (p->y - q->y) * (p->y - q->y));
}

int side(struct xy *p, struct xy *q, struct xy *r)
{
	double a = q->y - p->y;
	double b = p->x - q->x;
	double c = q->x * p->y - p->x * q->y;
	double tmp = a * r->x + b * r->y + c;

	if(tmp > PREC)
		return(-1);
	if(tmp < -PREC)
		return(1);
	return(0);
}

int main()
{
	int i, j, m, crossed;
	double l2, lm, ltmp;

	freopen("pendula.in", "r", stdin);
	scanf("%lf%d", &len, &n);
	for(i = 0; i < n; i++)
		scanf("%lf%lf", &a[i].x, &a[i].y);
	cont.x = a->x - 1;
	cont.y = a->y;

	freopen("pendula.out", "w", stdout);
	for(i = 0; ; printf("%d\n", (i = m) + 1)) {
		l2 = len * len - PREC;
		for(j = 0; j < n; j++) {
			if(i == j)
				continue;
			if((ltmp = dist(a + i, a + j)) < l2)
				goto out;
		}
		return(0);
	out:
		crossed = (side(a + i, &cont, a + j) >= 0);
		for(m = j, lm = ltmp; j < n; j++) {
			if(i == j)
				continue;
			if((ltmp = dist(a + i, a + j)) >= l2)
				continue;
			switch(side(a + i, a + m, a + j)) {
			case 0:
				if(crossed) {
					if(side(a + i, &cont, a + j) < 0)
						continue;
					if(ltmp < lm)
						continue;
				} else {
					if(side(a + i, &cont, a + j) >= 0)
						crossed = 1;
					else if(ltmp < lm)
						continue;
				}
				lm = ltmp, m = j;
				continue;
			case -1:
				if(crossed) {
					if(side(a + i, &cont, a + j) < 0)
						continue;
				} else crossed = (side(a + i, &cont, a + j) >= 0);
				lm = ltmp, m = j;
				continue;
			case 1:
				if(crossed)
					continue;
				if(side(a + i, &cont, a + j) < 0)
					continue;
				crossed = 1;
				lm = ltmp, m = j;
			}
		}
		len -= sqrt(lm);
		cont.x = 2 * a[m].x - a[i].x;
		cont.y = 2 * a[m].y - a[i].y;
	}
}
