/* small memory model */
#pragma option -3 -r -Z -O2 -a -ff -f287
#include <stdio.h>
#include <alloc.h>

int solve_dbl(int n)
{
	double far *a[250];
	long double x, y;
	int i, j, k, tmp;

	for(i = 0; i < n; i++)
		if((a[i] = farmalloc(sizeof(double) * n)) == (void far *) 0) {
			for(; i; farfree(a[--i])) ;
			return(1);
		}
	for(i = 0; i < n; i++)
		for(j = 0; j < n; a[i][j++] = tmp)
			scanf("%d", &tmp);
	for(k = 0; k < n; k++) {
		x = 1 / (long double) a[k][k];
		for(i = k + 1; i < n; i++) {
			y = a[i][k] * x;
			for(j = k + 1; j < n; j++)
				a[i][j] -= a[k][j] * y;
		}
		for(i = k + 1; i < n; i++)
			a[k][i] *= x;
	}
	freopen("lufact.out", "wb", stdout);
	for(i = 0; i < n; putchar('\r'), putchar('\n'), i++)
		for(j = 0; j <= i; j++)
			printf("%.8f ", a[i][j]);
	for(i = 0; i < n; putchar('\r'), putchar('\n'), i++)
		for(putchar('1'), j = i + 1; j < n; j++)
			printf(" %.8f", a[i][j]);
	return(0);
}

int solve_flt(int n)
{
	float far *a[250];
	long double x, y;
	int i, j, k, tmp;

	for(i = 0; i < n; i++)
		if((a[i] = farmalloc(sizeof(float) * n)) == (void far *) 0) {
			fputs("out of memory\n", stderr);
			return(1);
		}
	for(i = 0; i < n; i++)
		for(j = 0; j < n; a[i][j++] = tmp)
			scanf("%d", &tmp);
	for(k = 0; k < n; k++) {
		x = 1 / (long double) a[k][k];
		for(i = k + 1; i < n; i++) {
			y = a[i][k] * x;
			for(j = k + 1; j < n; j++)
				a[i][j] -= a[k][j] * y;
		}
		for(i = k + 1; i < n; i++)
			a[k][i] *= x;
	}
	freopen("lufact.out", "wb", stdout);
	for(i = 0; i < n; putchar('\r'), putchar('\n'), i++)
		for(j = 0; j <= i; j++)
			printf("%.8f ", a[i][j]);
	for(i = 0; i < n; putchar('\r'), putchar('\n'), i++)
		for(putchar('1'), j = i + 1; j < n; j++)
			printf(" %.8f", a[i][j]);
	return(0);
}

int main()
{
	int n;

	freopen("lufact.in", "rb", stdin);
	scanf("%d", &n);
	if(solve_dbl(n))
		return(solve_flt(n));
	return(0);
}
