/* small memory model */
#pragma option -3 -r -Z -O2 -a
#include <stdio.h>
#include <dos.h>

#define a	((int (_es *)[32]) 0)

unsigned seg;
int lnk[5];
unsigned char t[1000];

static const int cnt_bits[32] = {
	0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4,
	1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5
};

#define cur	xa[1]
#define old	(*xa)

void update(int (_es *xa)[32])
{
	static const int order[32] = {
		31, 23, 27, 29, 30, 15, 21, 22,
		11, 25, 26, 13, 28, 14,  7, 19,
		12,  6, 24,  3,  9, 17, 18, 10,
		20,  5,  8,  2,  1,  4, 16,  0
	};
	const int *p = order;
	int min, i, x, bk[32];

	do {
		for(min = 9999, x = i = 0; i < 5; i++) {
			if(*p & (1 << i))
				continue;
			x |= lnk[i];
			if(cur[*p | (1 << i)] < min) {
				min = cur[*p | (1 << i)];
				bk[*p] = bk[*p | (1 << i)]
					| ((*p | (1 << i)) << 8);
			}
		}
		if(old[x] + cnt_bits[*p] < min) {
			min = old[x] + cnt_bits[*p];
			bk[*p] = x | (*p << 8);
		}
		cur[*p] = min;
	} while(*(p++));
	for(i = 0; i < 32; i++)
		old[i] = bk[i];
}

#undef old
#undef cur

int main()
{
	int n, m, i, j, x, y;

	if(_dos_allocmem(4090, &seg)) {
		fputs("out of memory\n", stderr);
		return(1);
	}
	_ES = seg;
	for(i = 0; i < 32; i++)
		(*a)[i] = cnt_bits[i];
	freopen("hacker.in", "rb", stdin);
	scanf("%d", &n);
	for(i = 1; i < n; i++) {
		*lnk = lnk[1] = lnk[2] = lnk[3] = lnk[4] = 0;
		for(scanf("%d", &m); m--; lnk[y - 1] |= 1 << (x - 1))
			scanf("%d%d", &x, &y);
		_ES = seg;
		update(a + i - 1);
	}
	_ES = seg;
	for(m = 9999, i = 0; i < 32; i++)
		if(a[n - 1][i] < m)
			m = a[n - 1][j = i];
	for(i = n - 1; i; j = (unsigned char) a[--i][j])
		t[i] = a[i - 1][j] >> 8;
	*t = j;
	freopen("hacker.out", "w", stdout);
	printf("%d\n", m);
	for(i = 0; i < n; i++) {
		for(j = 0; j < 5; j++)
			if(t[i] & (1 << j))
				printf("%d ", j + 1);
		putchar('\n');
	}
	return(0);
}
