#include <stdio.h>
#include <stdlib.h>
/* please compile in LARGE model or on a serious OS (UNIX, that is) */

int *a[250];
float *r[250];
int n;
float diva;


void citeste(void)
{
	FILE * fin;
	int i,j;

	if(!(fin=fopen("LUFACT.IN","r"))){
		fprintf(stderr,"No can open input file :(\n");
		exit(42);
	}
	fscanf(fin,"%d",&n);
	for(i=0;i<n;i++)
		if(!(a[i]=(int *)malloc(n*sizeof(int)))){
			fprintf(stderr,"No can allocate %d ints...\n",n);
			exit(42);
		}
	for(i=0;i<n;i++)
		if(!(r[i]=(float *)malloc(n*sizeof(float)))){
			fprintf(stderr,"No can allocate %d floats...\n",n);
			exit(42);
		}
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			fscanf(fin,"%d",a[i]+j);
	fclose(fin);

}


void prel(void)
{
	int i,j,k;
	float tmp;
	int min;

	for(i=0;i<n;i++)
		r[i][0]=a[i][0];
	for(j=1;j<n;j++)
		r[0][j]=(float)a[0][j]/a[0][0];
	for(i=1;i<n;i++)
		for(j=1;j<n;j++){
			tmp=0.0;
			min=((i<j)?i:j);
			for(k=0;k<min;k++)
				tmp+=r[i][k]*r[k][j];
			if(i>=j)
				r[i][j]=((float)a[i][j]-tmp);
			else r[i][j]=((float)a[i][j]-tmp)/r[min][min];
		}

}

void afis(void)
{
	FILE * fout;
	int i,j;

	if(!(fout=fopen("LUFACT.OUT","w"))){
		fprintf(stderr,"No can open output file :(\n");
		exit(42);
	}
	for(i=0;i<n;i++){
		for(j=0;j<i+1;j++)
			fprintf(fout,"%.8f ",r[i][j]);
		fprintf(fout,"\n");
	}
	for(i=0;i<n;i++){
		fprintf(fout,"1 ");
		for(j=i+1;j<n;j++)
			fprintf(fout,"%.8f ",r[i][j]);
		fprintf(fout,"\n");
	}

	fclose(fout);
}


int main(void)
{
	citeste();
	prel();
	afis();

	fflush(NULL);
	return 0;
}